#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include "interval.h"

interval_t add (interval_t x, interval_t y) {
  interval_t result;
  result.lb = x.lb + y.lb;
  result.ub = x.ub + y.ub;
  return result;
}

interval_t sub (interval_t x, interval_t y) {
  interval_t result;
  result.lb = x.lb - y.ub;
  result.ub = x.ub - y.lb;
  return result;
}

interval_t mul (interval_t x, interval_t y) {
  interval_t result;
  result.lb = fmin( fmin(x.lb * y.lb, x.lb * y.ub),
		    fmin(x.ub * y.lb, x.ub * y.ub));
  result.ub = fmax( fmax(x.lb * y.lb, x.lb * y.ub),
		    fmax(x.ub * y.lb, x.ub * y.ub));
  return result;
}

char* interval2string (interval_t x) {
  int size = 100;
  char* str = malloc (size * sizeof(char));
  int n = sprintf (str, "[%.2f; %.2f]", x.lb, x.ub);
  if (n < 0) {
    return NULL;
  }
  if (n < size) {
    return str;
  }

  return NULL;
}
